classification
Title: Use of MutableMapping in os module slows down interpreter startup
Type: enhancement Stage: resolved
Components: Library (Lib) Versions: Python 3.4
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: christian.heimes Nosy List: Arfrever, barry, christian.heimes, eric.snow, haypo, pitrou, python-dev, r.david.murray, rhettinger
Priority: normal Keywords: patch

Created on 2013-10-10 18:08 by eric.snow, last changed 2014-02-26 18:26 by r.david.murray. This issue is now closed.

Files
File name Uploaded Description Edit
os-lazy-collections.diff eric.snow, 2013-10-10 18:35 review
Messages (14)
msg199402 - (view) Author: Eric Snow (eric.snow) * (Python committer) Date: 2013-10-10 18:08
There has been some discussion on python-dev about improving interpreter startup time.  Christian Heimes brought up how the os module imports collections (so _Environ can inherit from it) [1], and mentioned a couple of solutions [2].

[1]https://mail.python.org/pipermail/python-dev/2013-October/129312.html
[2]https://mail.python.org/pipermail/python-dev/2013-October/129367.html
msg199404 - (view) Author: Eric Snow (eric.snow) * (Python committer) Date: 2013-10-10 18:35
Here is a patch for an alternate approach.  It does not require re-implementing MutableMapping (could get out of sync) and does not require rearranging collections.abc.  Instead it uses a metaclass to resolve the import issue lazily.
msg199405 - (view) Author: Christian Heimes (christian.heimes) * (Python committer) Date: 2013-10-10 18:39
Nice trick :)
msg199406 - (view) Author: Eric Snow (eric.snow) * (Python committer) Date: 2013-10-10 18:45
And when the lazy base class gets resolved, the metaclass gets to say "You didn't see anything and I was never here." :)
msg199449 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2013-10-11 09:11
-1 on such hacks. I much prefer the _abcoll approach.
msg199450 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2013-10-11 09:14
The collections module is loaded by the io module. You removed "from collections.abc import MutableMapping" from os.py. To be useful, you have also to rewrite the whole io module to remove all references to the collections.abc module, right?
msg199520 - (view) Author: Christian Heimes (christian.heimes) * (Python committer) Date: 2013-10-11 23:07
The io module no longer imports collections.abc through the locale module.

Eric, I'm with Antoine. Your patch is too much of a clever hack and uses tricks that are dark magic. _abcoll is much simpler and easier to understand. Plus it can be used from other modules, too.
msg199521 - (view) Author: Eric Snow (eric.snow) * (Python committer) Date: 2013-10-11 23:17
Not a problem.  It is most definitely a hack. :)  I put in up as an alternative to rearranging the collections module, but agree that doing so is preferable.  I image that Raymond will make a decision on that one.
msg199642 - (view) Author: Raymond Hettinger (rhettinger) * (Python committer) Date: 2013-10-12 23:35
Christian, go ahead an rearrange the collections module.

Move Lib/collections/abc.py to Lib/_collections_abc.py.

Also, be sure to update source link on line 18 of Doc/library.collections.abc.rst
msg199644 - (view) Author: Roundup Robot (python-dev) Date: 2013-10-13 00:27
New changeset 0b6052f2a8ee by Christian Heimes in branch 'default':
Issue #19218: Rename collections.abc to _collections_abc in order to speed up interpreter start
http://hg.python.org/cpython/rev/0b6052f2a8ee

New changeset 7ea831581af4 by Christian Heimes in branch 'default':
Issue #19218: Add facade collections.abc
http://hg.python.org/cpython/rev/7ea831581af4

New changeset 62b6ecd1e463 by Christian Heimes in branch 'default':
Issue #19218: set __name__ of _collections_abc to collections.abc in order to fix tests and keep beautiful qualified names.
http://hg.python.org/cpython/rev/62b6ecd1e463
msg199647 - (view) Author: Christian Heimes (christian.heimes) * (Python committer) Date: 2013-10-13 00:53
Thank you very much for your input and assistance!

tip compared to v3.4.0a3:

### normal_startup ###
Min: 0.506533 -> 0.313627: 1.62x faster
Avg: 0.582504 -> 0.441796: 1.32x faster
Significant (t=19.98)
Stddev: 0.02397 -> 0.04366: 1.8213x larger
msg199654 - (view) Author: Eric Snow (eric.snow) * (Python committer) Date: 2013-10-13 04:54
Thanks, Christian.
msg212282 - (view) Author: R. David Murray (r.david.murray) * (Python committer) Date: 2014-02-26 18:12
For backward compatibility, shouldn't

  import _collections_abc

in the __init__ file be

  import _collections_abc as abc

?
msg212285 - (view) Author: R. David Murray (r.david.murray) * (Python committer) Date: 2014-02-26 18:26
Opened issue 20784 to address the above.
History
Date User Action Args
2014-02-26 18:26:34r.david.murraysetmessages: + msg212285
2014-02-26 18:12:54r.david.murraysetnosy: + r.david.murray
messages: + msg212282
2013-10-13 04:54:28eric.snowsetmessages: + msg199654
2013-10-13 00:53:34christian.heimessetstatus: open -> closed
resolution: fixed
messages: + msg199647

stage: patch review -> resolved
2013-10-13 00:27:54python-devsetnosy: + python-dev
messages: + msg199644
2013-10-12 23:35:39rhettingersetassignee: rhettinger -> christian.heimes
messages: + msg199642
2013-10-11 23:17:08eric.snowsetmessages: + msg199521
2013-10-11 23:07:09christian.heimessetmessages: + msg199520
2013-10-11 09:14:14hayposetnosy: + haypo
messages: + msg199450
2013-10-11 09:11:22pitrousetnosy: + pitrou
messages: + msg199449
2013-10-11 04:39:41Arfreversetnosy: + Arfrever
2013-10-11 04:11:05rhettingersetassignee: rhettinger

nosy: + rhettinger
2013-10-10 18:47:53barrysetnosy: + barry
2013-10-10 18:45:53eric.snowsetmessages: + msg199406
2013-10-10 18:39:24christian.heimessetmessages: + msg199405
2013-10-10 18:35:14eric.snowsetfiles: + os-lazy-collections.diff
keywords: + patch
messages: + msg199404

stage: needs patch -> patch review
2013-10-10 18:08:01eric.snowcreate